#include "TkXext.h"
#include "string.to.window.h"

int 
TkXext_DeleteOrKill TCL_OBJ_CMD_ARGS {
 Display *dis;
 Window w;
 Atom *wm_protocols = NULL;
 int num_items;
 int i;

 if (2 != objc) {
  Tcl_WrongNumArgs (interp, 1, objv, "Window");
  return TCL_ERROR;
 }

 if (TCL_OK != TkXext_StringToWindow (interp, Tcl_GetString (objv[1]), &w)) {
  return TCL_ERROR;
 }

 dis = Tk_Display (Tk_MainWindow (interp));

 if (XGetWMProtocols (dis, w, &wm_protocols, &num_items)) {
  for (i = 0; i < num_items; ++i) {
   if (TKXEXT_WM_DELETE_WINDOW == wm_protocols[i]) {
    XClientMessageEvent ev;

    ev.type = ClientMessage;
    ev.serial = LastKnownRequestProcessed (dis);
    ev.display = dis;
    ev.window = w;
    ev.message_type = TKXEXT_WM_PROTOCOLS;
    ev.format = 32;
    ev.data.l[0] = TKXEXT_WM_DELETE_WINDOW; 
    ev.data.l[1] = CurrentTime;
    XSendEvent (dis, w, 0, 0L, (XEvent *) &ev); 
    XFlush (dis);

    if (wm_protocols) 
     XFree (wm_protocols);
 
    return TCL_OK;
   }
  }
  if (wm_protocols)
   XFree (wm_protocols);
 }

 XKillClient (dis, w); 

 return TCL_OK;
}
